#include <stdio.h>
#define	TRUE	-1
#define FALSE	 0

FILE *fopen();

int fd,cyl,headmax,cs;
char secord[17] = {0,6,12,1,7,13,2,8,14,3,9,15,4,10,16,5,11};

main ()                                 /* formatting drive >>4077<< */

{
          getdata(&cyl,&headmax,&cs);                 /* cylinder,head */
          fd = open("/dev/DBinoutb",2);            /* file descriptor */
          dform(fd,cyl,headmax,cs,secord);         /* formatting */
}

/* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */





getdata(cyl,headmax,cs)                  /* get data from user */
 
int *cyl,*headmax,*cs;

         {

         printf ("%s\n","                     formatting");

         do
            {
            printf ("%s","card select: ");
            scanf ("%d",cs);
                     }
         while (test(*cs,255)==FALSE);

         do                                        /* get max cylinder */
           {
    	   printf ("%s","Cylinder: ");
           scanf ("%d",cyl);
                    }
        while (test(*cyl,10000)==FALSE);
 
        do                                        /* get max head */
          {
          printf ("%s","Head: ");
          scanf ("%d",headmax);
          printf ("%s\n","   ");
          }
        while (test(*headmax,16)==FALSE);

        printf ("%s\n","Cyl.       Head");


       }

/* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */ 





test(a,b)                           /* test if a<b, if not return FALSE */
 
        int a,b;
        {
        if (a <= b)
	        {
	         return(TRUE);
	        }
        else
	        {
	         return(FALSE);
	        } 
        }
/* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */
         




dform(fd,cyl,headmax,cs,secord)	/* drive format */

int fd,cyl,headmax,cs;                            
char secord[];


	{

  int cylinder,head;

  int datain,dataout,stat,c1,c2;                    /* strobe definitions */
  int restor,seek,format;                              /* commands */
  int fifo,wpc,err,scnt,snum,cyll,cylh,sdh,comm,sreg;  /* register numbers */
  int ecc;                              /* ECC 512 bytes drive 0 */
  int i,fdata;                            /* dummy integer */
  int pccyl;				  /* precomp cylinder = 128 */
  int reset; 
 
 
  datain = cs * 256 + 0;
  dataout = datain;
  stat = cs * 256 + 1;
  c1 = cs * 256 + 2;
  c2 = cs * 256 + 3;

  restor = 16 + 0;
  seek = 112 + 0;
  format = 80;

  fifo = 0 + 192;
  wpc = 0 + 192;        /* write precomp cylinder */
  err = 1 + 192;        /* error register */
  scnt = 2 + 192;       /* sector count */
  snum = 3 + 192;       /* sector number */
  cyll = 4 + 192;       /* cylinder low */
  cylh = 5 + 192;       /* cylinder high */
  sdh = 6 + 192;        /* SDH register */
  comm = 7 + 192;       /* command register */
  sreg = 7 + 192;       /* status register */      

  ecc = 128+32+0+0;                     /* ext + size + drive + head */
  pccyl = 32;
  reset = 7;

	 out(fd,c1,reset);		   /* reset */

	 
	 out(fd,c1,sdh);                   /* RESTOR */
         out(fd,dataout,ecc);              
	 out(fd,c1,comm);
         out(fd,dataout,restor);




	 for (cylinder = 0; cylinder <= cyl; cylinder = cylinder + 1)
         	{
                for (head = 0; head <= headmax; head = head + 1)
                 	{

		        out(fd,c1,fifo);
                        for (i = 0; i <= 511 - 17; i = i + 1)
                        	{
                                if (i <= 16)
					{
                                	fdata = secord[i];
					out(fd,dataout,0);
					out(fd,dataout,fdata);
					}
                                else 
					{
                                        fdata = 255;
                                        out(fd,dataout,fdata);
					}
                                }
                        out(fd,c1,sreg);
                           
  			do
	       			i = (inp(fd,stat) & 255);
  			while (i < 128);
			
			i = inp(fd,datain);		 
			if ((i & 1) != 0)
                 		{
				printf("%s\n","error in dform(x)");
				exit(FALSE);
				}

			printf("%1d",cylinder);
			printf("%11d\n",head);

			
                	out(fd,c1,wpc);
			out(fd,dataout,pccyl);
			out(fd,c1,scnt);
			out(fd,dataout,17);	/* sector per track */
			out(fd,c1,snum);
			out(fd,dataout,10);     /* gap 10 + 3 bytes */
			out(fd,c1,cyll);
			out(fd,dataout,(cylinder & 255)); 
			out(fd,c1,cylh);
			out(fd,dataout,(cylinder / 256));
			out(fd,c1,sdh);
			out(fd,dataout,128+32+0+head);
			out(fd,c1,comm);
			out(fd,dataout,format);

			do
				i = (inp(fd,stat) & 255);
	          	while (i < 128);

			out(fd,c1,64 + sreg - 192);	/* reset fifo */
			}
		}

	printf("%2d\n",(inp(fd,stat) & 255));
	
	}

/* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */





out(a,b,c)			/* a=filedescriptor b=strobe c=data */

int a,b,c;

 	{
char intchar;			/* int --> char */	

	intchar = c;
	lseek(a,b,0);
	write(a,&intchar,1);
	}

/* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */






inp(a,b)			/* a=filedescriptor b=strob c=dummy */

int a,b;

	{
        char c[1];

        	lseek(a,b,0);
	        read(a,c,1);
        	return(c[0]);
	}


			
