#include "/usr/mk/header/tests.h"
#include "/usr/mk/sp1656/constant.h"
#include "/usr/mk/sp1656/cmdadaptec.h"

char sens[30];						/* sense bytes */
unsigned char buffer[512];				/* 512 byte buffer */
unsigned int toterr = 0;				/* total errnum */
unsigned char rad = 0;					/* rad for list err */
struct errerr{
             unsigned int num;		/* error number */
             char cmd[6];		/* command  read/write */
             unsigned int bl;		/* block */
             unsigned int cyl;		/* cylinder */
             unsigned char head;	/* head */
             unsigned int bfind;	/* byte from index */
             char errstr[35];		/* error string */
             };

struct errerr errdata[50];

w_main()


{
extern unsigned char buffer[];
unsigned char write[],read[];
long tstnr = 0;		
char mswd[];
char dump,i;
int unsigned block,lastbl,j,mblock = 0;
int rand();
char unsigned errcode,hshake;
char *errorcode();
int hdmax;


	printf ("\n\n%s\n\n","Winchester test:            slutprov ABC1656"); 
	


/* test unit ready --------------------------------------------- */


        if (csa(IDW)) handshake();
	if (sndcmd(urwc)) handshake();
	if (iferror() != TRUE)
		{
		printf ("%s\n","Unit not ready:  \"winchester\"");
		exit();
		}


/* set error threshold = 1 --------------------------------------- */


	if (csa(IDW)) handshake();
        if (sndcmd(errt)) handshake();	
        if (iferror() != TRUE)	
                {	
                printf ("%s\n","Error threshold:  \"winchester\"");
                exit();
                }

/* formatting winchester ----------------------------------------- */

	printf("%s","Skall winchestern formateras:   (j/n)   j ");
	if (yesno() != FALSE)
		{
		printf ("\n\n");
		basicdr(mswd);				/* which drive */
	        if (csa(IDW)) handshake();
		if (sndcmd(mswc)) handshake();          /* msw = mode sel. */
		if (snddat(mswd)) handshake();          /* msdw = ms data */
		if (iferror() != TRUE)                  /* check error */
			{
			printf ("\n%s\n","mode select command error");
			exit();
			}

		printf ("\nformatering: ");
                if (csa(IDW)) handshake();
		if (sndcmd_req(forw)) handshake();	/* forw = form. wi. */
		if (iferror() != TRUE)			/* check error */
                        {
                        printf ("\nkan ej formatera. !!!\n");
                        exit();
                        }
		}

        if (csa(IDW)) handshake();
	if (sndcmd(msen)) handshake();                  /* mode sense */
        if (getdat()) handshake();
        if (iferror() != TRUE)
                {
                printf ("\n%s\n","mode sense error");
                exit();
                }
	hdmax = buffer[0x0f];




/* get address of max block ----------------------------------------- */



        if (csa(IDW)) handshake();
        if (sndcmd(rcwc)) handshake();
	if (getdat()) handshake();
	if (iferror() != TRUE)
                {
                printf ("\n%s\n","can't read READ CAPACITY");
                exit();
                }


	mblock = mblock + buffer[0] * 256 * 256 * 256;
	mblock = mblock + buffer[1] * 256 * 256;
	mblock = mblock + buffer[2] * 256;
	mblock = mblock + buffer[3];
	mblock = mblock / 32768;			/* help rand() */


/* random write/read test --------------------------------------------- */


	wmonit(1);					/* winchester mon */

	for (i=0; i < 6; i++)				/* can block change */
		{
		write[i] = wrwc[i];
		read[i] = rdwc[i];
		}

	block = 0; 
	while (key() != TRUE)
		{
		lastbl = block;
		block = rand()*mblock ^ rand();

		printf ("%s%-9d","     LBA ",block);
		printf ("%s%-15d%s\r","   Test nr: ",tstnr," read/write    ");
		tstnr++;

		read[3] = block;
		read[2] = (block >> 8);
		read[1] = read[1] & 0xe0 + (block >> 16);
		write[3] = block;
		write[2] = (block >> 8);
		write[1] = write[1] & 0xe0 + (block >> 16);

	/* random routin     ---------> */

		hshake = 0;
		if (csa(IDW)) hshake++;	            	 /* ID winchester */
		if (sndcmd(read)) hshake++;              /* read command */
		if (getdat()) hshake++;	                 /* get data */
			if (i = iferror() != TRUE)
				{
				if (i =! 1)
					logerror("read",block,lastbl,hdmax,0);
				else 
					hshake++;
 				}

		if (hshake != 0)
			{
			outb(SASIRST,0);	/* handshake error */
			logerror("read",block,lastbl,hdmax,1);
			hshake = 0;
			}
                if (csa(IDW)) hshake++;                /* ID winchester */
		if (sndcmd(write)) hshake++;	       /* write command */
		if (snddat(buffer)) hshake++;          /* write buffer */
                        if (i = iferror() != TRUE)
                                {
                                if (i =! 1)
                                       logerror("write",block,lastbl,hdmax,0);
                                else
                                        hshake++;
                                }

                if (hshake != 0)
                        {
                        outb(SASIRST,0);        /* handshake error */
			logerror("write",block,lastbl,hdmax,1);
                        }
		}

/* ccc ccc ccc ccc ccc ccc ccc ccc ccc ccc ccc ccc */


        printf ("\n\n\n\n");
        printf ("Skall STREAMER testas       (j/n)   j ");
        if (yesno() == TRUE)
                {
                printf ("\n\n");
                t_main();                       /* streamer test */
                }
        printf ("\n\n");
        exit();                                 /* no error */
}
	
