	/* read sector */



wrsector(fd,cyl,head,sec,cs)				

int fd,cyl,head,sec,cs; 

{
  int datain,dataout,stat,c1,c2;                    /* strobe definitions */
  int wrsec;                                        /* commands */
  int snum,cyll,cylh,sdh,comm,sreg;                 /* register numbers */
  int sdhdata;					    /* ext,size,drive,head */
  int i;
  int pccyl,wpc,scnt,sectors;

  datain = cs * 256 + 0;
  dataout = datain;
  stat = cs * 256 + 1;
  c1 = cs * 256 + 2;
  c2 = cs * 256 + 3;

  wrsec = 48;

  sdhdata = 128 + 32 + head;			    /* size 512 bytes */

  cyll = 4 + 192;                                   /* cylinder low */
  cylh = 5 + 192;                                   /* cylinder high */
  sdh = 6 + 192;                                /* SDH register */        
  comm = 7 + 192;                               /* command register */
  sreg = 7 + 192;                               /* status register */     
  wpc = 1 + 192;
  scnt = 2 + 192;
  snum = 3 + 192;

  pccyl = 32;
  sectors = 17;	


	out(fd,c1,wpc);
	out(fd,dataout,pccyl);
	out(fd,c1,scnt);
	out(fd,dataout,sectors);
	out(fd,c1,snum);
	out(fd,dataout,sec);
	
       	out(fd,c1,cyll);			   /* current cyl. position */
	out(fd,dataout,(cyl & 255));
	out(fd,c1,cylh);
	out(fd,dataout,(cyl/255));
	out(fd,c1,sdh);
        out(fd,dataout,sdhdata);		   /* ext,size,drive,head */
	out(fd,c1,comm);
        out(fd,dataout,wrsec);		           /* write sector */
	
		do
			{
			i = (inp(fd,stat) & 255);
			printf ("%X\n",i);
			}
		while (i < 128); 

	out(fd,c1,sreg);
	return(inp(fd,dataout) & 255);
}
